Index: /trunk/BIOS_Drive_Information_Tool/Src/AtaInfo.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/AtaInfo.asm	(revision 425)
+++ /trunk/BIOS_Drive_Information_Tool/Src/AtaInfo.asm	(revision 426)
@@ -64,12 +64,12 @@
 .SkipLBA48:
 
+	; Print block mode information
+	call	DisplayBlockModeInformationUsingAtaInfoFromDSBX
+
+	; Print PIO mode information
+	call	DisplayPioModeInformationUsingAtaInfoFromDSBX
+
 	; Print L-CHS generated by XTIDE Universal BIOS
 	call	DisplayXTUBcompatibilityInfoUsingAtaInfoFromDSBX
-
-	; Print block mode information
-	call	DisplayBlockModeInformationUsingAtaInfoFromDSBX
-
-	; Print PIO mode information
-	call	DisplayPioModeInformationUsingAtaInfoFromDSBX
 
 .SkipAtaInfoSinceError:
@@ -166,33 +166,4 @@
 
 ;--------------------------------------------------------------------
-; DisplayXTUBcompatibilityInfoUsingAtaInfoFromDSBX
-;	Parameters:
-;		BX:		Offset to ATA Information
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, CX, DX, BP, SI, DI
-;--------------------------------------------------------------------
-DisplayXTUBcompatibilityInfoUsingAtaInfoFromDSBX:
-	push	bx
-
-	; Display header
-	mov		ax, g_szXTUBversion
-	mov		si, g_szXTUB
-	call	Print_FormatStringFromSIwithParameterInAX
-
-	; Display translation mode and L-CHS
-	mov		si, bx				; DS == ES
-	mov		dx, TRANSLATEMODE_AUTO
-	call	AtaGeometry_GetLCHStoAXBLBHfromAtaInfoInESSIandTranslateModeInDX
-	dec		ax					; Reserve diagnostics cylinder
-	MIN_U	ax, MAX_LCHS_CYLINDERS
-	call	Print_ModeFromDLandCHSfromAXLBH
-
-	pop		bx
-	ret
-
-
-;--------------------------------------------------------------------
 ; DisplayBlockModeInformationUsingAtaInfoFromDSBX
 ;	Parameters:
@@ -205,5 +176,5 @@
 DisplayBlockModeInformationUsingAtaInfoFromDSBX:
 	eMOVZX	ax, BYTE [bx+ATA1.bBlockSel]	; ATA2+ has flag on high word
-	mov		dx, [bx+ATA1.bBlckSize]
+	eMOVZX	dx, BYTE [bx+ATA1.bBlckSize]
 	mov		si, g_szBlockMode
 	jmp		Print_FormatStringFromSIwithParametersInAXDX
@@ -247,2 +218,26 @@
 	dw		PIO_1_MIN_CYCLE_TIME_NS
 	dw		PIO_2_MIN_CYCLE_TIME_NS
+
+
+;--------------------------------------------------------------------
+; DisplayXTUBcompatibilityInfoUsingAtaInfoFromDSBX
+;	Parameters:
+;		BX:		Offset to ATA Information
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX, BP, SI, DI
+;--------------------------------------------------------------------
+DisplayXTUBcompatibilityInfoUsingAtaInfoFromDSBX:
+	; Display header
+	mov		ax, g_szXTUBversion
+	mov		si, g_szXTUB
+	call	Print_FormatStringFromSIwithParameterInAX
+
+	; Display translation mode and L-CHS
+	mov		si, bx				; DS == ES
+	mov		dx, TRANSLATEMODE_AUTO
+	call	AtaGeometry_GetLCHStoAXBLBHfromAtaInfoInESSIandTranslateModeInDX
+	dec		ax					; Reserve diagnostics cylinder
+	MIN_U	ax, MAX_LCHS_CYLINDERS
+	jmp		Print_ModeFromDLandCHSfromAXLBH
Index: /trunk/BIOS_Drive_Information_Tool/Src/Print.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 425)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 426)
@@ -140,9 +140,5 @@
 	mov		bp, sp
 
-	xor		dh, dh
-	mov		si, dx
-	shl		si, 1		; Shift for WORD lookup
-	push	WORD [si+.rgszXlateModeToString]
-
+	; Push CHS parameters
 	ePUSH_T	si, g_szFormatCHS
 	push	ax			; Cylinders
@@ -152,5 +148,11 @@
 	push	ax			; Sectors per track
 
-	mov		si, g_szXlateAndCHS
+	; Push translation mode
+	xor		dh, dh
+	mov		si, dx
+	shl		si, 1		; Shift for WORD lookup
+	push	WORD [si+.rgszXlateModeToString]
+
+	mov		si, g_szChsAndMode
 	jmp		SHORT JumpToFormatNullTerminatedStringFromSI
 
@@ -181,4 +183,5 @@
 	mov		si, g_szFormatCHS
 	CALL_DISPLAY_LIBRARY	FormatNullTerminatedStringFromCSSI
+	CALL_DISPLAY_LIBRARY	PrintNewlineCharacters
 
 	pop		si
Index: /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 425)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 426)
@@ -31,15 +31,15 @@
 
 g_szAtaInfoHeader:	db	"ATA-information from AH=25h...",CR,LF,NULL
-g_szFormatDrvName:	db	" Name: %s",CR,LF,NULL
-g_szXlateAndCHS:	db	" Mode: %s, %s",NULL
+g_szFormatDrvName:	db	" Name         : %s",CR,LF,NULL
+g_szChsAndMode:		db	"%s, Mode: %s",CR,LF,NULL
 g_szNormal:			db	"NORMAL",NULL
 g_szLarge:			db	"LARGE ",NULL
 g_szLBA:			db	"LBA   ",NULL
-g_szFormatCHS:		db	" Cylinders    : %5-u, Heads: %3-u, Sectors: %2-u",CR,LF,NULL
+g_szFormatCHS:		db	" Cylinders    : %5u, Heads: %3u, Sectors: %2u",NULL
 g_szChsSectors:		db	" CHS   sectors: ",NULL
 g_szLBA28:			db	" LBA28 sectors: ",NULL
 g_szLBA48:			db	" LBA48 sectors: ",NULL
-g_szBlockMode:		db	" Block set    : %u, Max block: %u sectors",CR,LF,NULL
-g_szPIO:			db	" Max PIO mode : %u, Min cycle time without IORDY %u, with IORDY %d ns",CR,LF,NULL
+g_szBlockMode:		db	" Block mode   : Set to %u from max %u sectors",CR,LF,NULL
+g_szPIO:			db	" PIO mode     : Max %u, Min cycle times: %u ns, with IORDY %d ns",CR,LF,NULL
 g_szXTUB:			db	"XTIDE Universal BIOS %s generates following L-CHS...",CR,LF,NULL
 g_szXTUBversion:	db	ROM_VERSION_STRING	; This one is NULL terminated