Index: trunk/Assembly_Library/Inc/Emulate.inc
===================================================================
--- trunk/Assembly_Library/Inc/Emulate.inc	(revision 488)
+++ trunk/Assembly_Library/Inc/Emulate.inc	(revision 489)
@@ -469,4 +469,5 @@
 
 %macro eSHL_IM 2
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %ifdef USE_386
 	%if %2 = 1
@@ -478,4 +479,5 @@
 	eSHIFT_IM	%1, %2, shl
 %endif
+%endif
 %endmacro
 
Index: trunk/Assembly_Library/Src/Display/CgaSnow.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 489)
@@ -94,5 +94,5 @@
 	ret
 
-
+%ifdef INCLUDE_MENU_LIBRARY
 ;--------------------------------------------------------------------
 ; CgaSnow_RepMovsb
@@ -122,5 +122,5 @@
 	eSEG_STR rep, es, movsb
 	ret
-
+%endif
 
 ;--------------------------------------------------------------------
Index: trunk/Assembly_Library/Src/Display/DisplayContext.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayContext.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Display/DisplayContext.asm	(revision 489)
@@ -102,4 +102,6 @@
 
 
+%ifdef INCLUDE_MENU_LIBRARY
+
 ;--------------------------------------------------------------------
 ; DisplayContext_Push
@@ -157,5 +159,5 @@
 	mov		ds, di					; Restore DS
 	ret
-
+%endif
 
 ;--------------------------------------------------------------------
@@ -187,5 +189,6 @@
 	pop		ds
 	ret
-%endif
+
+%endif  ; INCLUDE_MENU_LIBRARY
 
 
@@ -228,4 +231,5 @@
 %endif
 
+%ifdef INCLUDE_MENU_LIBRARY
 
 ;--------------------------------------------------------------------
@@ -247,5 +251,5 @@
 	mov		[VIDEO_BDA.displayContext+DISPLAY_CONTEXT.fnCharOut], ax
 	ret
-		
+
 
 ;--------------------------------------------------------------------
@@ -279,5 +283,6 @@
 	mov		[VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCharOutParam], ax
 	ret
-
+		
+%endif	 ; INCLUDE_MENU_LIBRARY
 		
 ;--------------------------------------------------------------------
Index: trunk/Assembly_Library/Src/Display/DisplayCursor.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayCursor.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Display/DisplayCursor.asm	(revision 489)
@@ -37,5 +37,5 @@
 	ret
 
-
+%ifdef INCLUDE_MENU_LIBRARY
 ;--------------------------------------------------------------------
 ; DisplayCursor_SetShapeFromAX
@@ -52,6 +52,6 @@
 	mov		[VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCursorShape], ax
 	ret
-
-
+%endif
+		
 ;--------------------------------------------------------------------
 ; DisplayCursor_SetCoordinatesFromAX
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 489)
@@ -220,4 +220,5 @@
 
 
+%ifdef INCLUDE_MENU_LIBRARY
 ;--------------------------------------------------------------------
 ; DisplayPrint_ClearScreenWithCharInALandAttributeInAH
@@ -249,6 +250,6 @@
 	mov		[VIDEO_BDA.displayContext+DISPLAY_CONTEXT.fpCursorPosition], di
 	ret
-
-
+%endif
+		
 ;--------------------------------------------------------------------
 ; DisplayPrint_ClearAreaWithHeightInAHandWidthInAL
Index: trunk/Assembly_Library/Src/Menu/MenuInit.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 489)
@@ -137,5 +137,6 @@
 	ret
 
-
+		
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS		
 ;--------------------------------------------------------------------
 ; MenuInit_HighlightItemFromAX
@@ -152,5 +153,7 @@
 	sub		ax, [bp+MENUINIT.wHighlightedItem]
 	jmp		MenuScrollbars_MoveHighlightedItemByAX
-
+%endif
+
+		
 ;--------------------------------------------------------------------
 ; MenuInit_GetHighlightedItemToAX
Index: trunk/Assembly_Library/Src/Menu/MenuLocation.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 489)
@@ -55,5 +55,7 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS		
 MenuLocation_GetItemBordersTopLeftCoordinatesToAX:
+%endif
 	xor		ax, ax
 	jmp		SHORT AddItemBordersTopLeftCoordinatesToAX
Index: trunk/Assembly_Library/Src/String/Char.asm
===================================================================
--- trunk/Assembly_Library/Src/String/Char.asm	(revision 488)
+++ trunk/Assembly_Library/Src/String/Char.asm	(revision 489)
@@ -181,4 +181,5 @@
 %endif
 
+				
 ;--------------------------------------------------------------------
 ; Char_ALtoUpperCaseLetter
@@ -190,4 +191,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS		
 ALIGN STRING_JUMP_ALIGN
 Char_ALtoUpperCaseLetter:
@@ -196,5 +198,7 @@
 	jnc		SHORT Char_ChangeCaseInAL.Return
 	; Fall to Char_ChangeCaseInAL
-
+%endif
+
+		
 ;--------------------------------------------------------------------
 ; Char_ChangeCaseInAL
Index: trunk/Assembly_Library/Src/Time/TimerTicks.asm
===================================================================
--- trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 489)
@@ -57,4 +57,5 @@
 %endif ; EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 
+%ifdef INCLUDE_MENU_LIBRARY
 ALIGN JUMP_ALIGN
 TimerTicks_GetSecondsToAXfromTicksInDX:
@@ -65,5 +66,5 @@
 	xchg	dl, ah	; Seconds in AX, remainder in DX
 	ret
-
+%endif
 
 ;--------------------------------------------------------------------
@@ -81,4 +82,5 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifdef INCLUDE_MENU_LIBRARY		
 ALIGN JUMP_ALIGN
 TimerTicks_InitializeTimeoutFromAX:
@@ -87,5 +89,5 @@
 	add		[bx], ax					; [bx] now contains end time for timeout
 	ret
-
+%endif
 
 ;--------------------------------------------------------------------
@@ -100,4 +102,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifdef INCLUDE_MENU_LIBRARY		
 ALIGN JUMP_ALIGN
 TimerTicks_GetTimeoutTicksLeftToAXfromDSBX:
@@ -109,5 +112,5 @@
 	pop		dx
 	ret
-
+%endif
 
 ;--------------------------------------------------------------------
Index: trunk/Assembly_Library/Src/Util/Memory.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Memory.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Util/Memory.asm	(revision 489)
@@ -79,4 +79,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifdef INCLUDE_MENU_LIBRARY
 ALIGN JUMP_ALIGN
 Memory_ZeroSSBPwithSizeInCX:
@@ -90,5 +91,7 @@
 	pop		es
 	ret
+%endif
 
+		
 ;--------------------------------------------------------------------
 ; Memory_ZeroESDIwithSizeInCX
Index: trunk/Assembly_Library/Src/Util/Registers.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Registers.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Util/Registers.asm	(revision 489)
@@ -53,7 +53,9 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
+%ifdef INCLUDE_MENU_LIBRARY		
 Registers_CopySSBPtoESDI:
 	COPY_SSBP_TO_ESDI
 	ret
+%endif
 
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
Index: trunk/Assembly_Library/Src/Util/Size.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Size.asm	(revision 488)
+++ trunk/Assembly_Library/Src/Util/Size.asm	(revision 489)
@@ -18,4 +18,5 @@
 ;		
 
+%ifdef INCLUDE_MENU_LIBRARY
 struc BYTE_MULTIPLES
 	.B			resb	1
@@ -82,5 +83,5 @@
 	ret
 .rgbMagnitudeToChar:	db	" kMGTP"
-
+%endif
 
 ;--------------------------------------------------------------------
@@ -111,5 +112,4 @@
 	ret
 
-
 ;--------------------------------------------------------------------
 ; Size_ConvertSectorCountInBXDXAXtoKiB
@@ -124,5 +124,5 @@
 ;--------------------------------------------------------------------
 ALIGN UTIL_SIZE_JUMP_ALIGN
-Size_ConvertSectorCountInBXDXAXtoKiB:
+Size_ConvertSectorCountInBXDXAXtoKiB:               ; unused entrypoint ok
 Size_DivideBXDXAXbyTwo:
 	shr		bx, 1					; Divide sector count by 2...