Index: /wiki/BuildInstructions.wiki
===================================================================
--- /wiki/BuildInstructions.wiki	(revision 493)
+++ /wiki/BuildInstructions.wiki	(revision 494)
@@ -97,5 +97,5 @@
 # Following modules can be included or excluded:                                                   #
 # MODULE_8BIT_IDE             Support for 8-BIT IDE cards like XTIDE                               #
-# MODULE_JRIDE                Support for JR-IDE/ISA                                               #
+# MODULE_8BIT_IDE_ADVANCED	  Support for memory mapped and DMA based cards like JRIDE and XTCF    #
 # MODULE_ADVANCED_ATA         Native support for some VLB IDE controllers                          #
 # MODULE_BOOT_MENU            Boot Menu for selection of drive to boot from                        #
@@ -116,4 +116,5 @@
 # USE_386                     Use instructions supported by 386 and later                          #
 # USE_AT                      Use features supported on AT and later systems (not available on XT) #
+# USE_UNDOC_INTEL             Optimizations for Intel CPU:s - do NOT use on NEC V20/V30/Sony CPU:s #
 #                                                                                                  #
 ####################################################################################################
@@ -128,9 +129,9 @@
 #################################################################
 DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_EBIOS MODULE_FEATURE_SETS RESERVE_DIAGNOSTIC_CYLINDER
-DEFINES_COMMON_LARGE = MODULE_BOOT_MENU
-
-DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE MODULE_JRIDE MODULE_SERIAL MODULE_SERIAL_FLOPPY
+DEFINES_COMMON_LARGE = MODULE_BOOT_MENU MODULE_8BIT_IDE MODULE_8BIT_IDE_ADVANCED
+
+DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE MODULE_SERIAL MODULE_SERIAL_FLOPPY
 DEFINES_XTPLUS = $(DEFINES_COMMON) $(DEFINES_XT) USE_186
-DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 RELOCATE_INT13H_STACK MODULE_IRQ MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_ADVANCED_ATA
+DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 USE_UNDOC_INTEL RELOCATE_INT13H_STACK MODULE_IRQ MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_ADVANCED_ATA 
 
 DEFINES_XT_LARGE = $(DEFINES_XT) $(DEFINES_COMMON_LARGE)
@@ -140,5 +141,4 @@
 DEFINES_XT_TINY = MODULE_STRINGS_COMPRESSED MODULE_8BIT_IDE
 DEFINES_386_8K = $(DEFINES_AT) USE_386
-
 
 ###################
@@ -171,12 +171,12 @@
 This module contains support for XTIDE rev 1 and 2 and Lo-tech XT-CF.
 
-====*MODULE_JRIDE* _(requires and automatically includes MODULE_8BIT_IDE)_====
-This module contains support for JR-IDE/ISA.
+====*MODULE_8BIT_IDE_ADVANCED* _(requires and automatically includes MODULE_8BIT_IDE)_====
+This module contains support for JR-IDE/ISA and more advanced modes for XT-CF.
 
 ====*MODULE_ADVANCED_ATA*====
 Adds native support for VLB (and eventually PCI) IDE Controllers. At the moment there is support for QDI Vision QD6500 and QD6580 VLB IDE controllers.
 
-====*MODULE_BOOT_MENU* _(requires and automatically includes MODULE_HOTKEYS)_====
-Adds boot menu to be selected from Hotkeybar. Boot menu displays drive details and allows selecting drive more easily but essentially it has all the same features as MODULE_HOTKEYS.
+====*MODULE_BOOT_MENU*====
+Adds boot menu to be selected from Hotkeybar. Boot menu displays drive details and allows selecting drive more easily but essentially it has all the same features as MODULE_HOTKEYS.  It can also be included without MODULE_HOTKEYS, in which case the menu is always entered during the boot process.
 
 ====*MODULE_IRQ*====
Index: /wiki/Manual_v2_0_0.wiki
===================================================================
--- /wiki/Manual_v2_0_0.wiki	(revision 493)
+++ /wiki/Manual_v2_0_0.wiki	(revision 494)
@@ -211,4 +211,6 @@
 F2 displays boot menu (available only if MODULE_BOOT_MENU is available).
 
+F6 will search for virtual serial drives on COM ports 1-7 at the end of standard drive detection (available only if MODULE_SERIAL is available). 
+
 F8 calls software interrupt 18h. This starts IBM ROM Basic, ROM DOS or displays an error message from the motherboard BIOS when there is no ROM to boot from.
 
@@ -222,10 +224,4 @@
 
 Using the boot menu is optional and it is not included in official 8 kiB builds. Boot menu does not offer any more functionality than hotkeys except to display drive information. Drive can be selected with Up and Down arrows. Home, End, PgUp and PgDn keys can speed up selection if there are many drives in the boot menu. Press Enter to boot from selected drive.
-
-
-== Boot menu hotkeys ==
-
-All hotkeys from Hotkeybar are available when Boot Menu is displayed.
-
 
 == Boot menu drive information ==
Index: /wiki/SerialDrives.wiki
===================================================================
--- /wiki/SerialDrives.wiki	(revision 493)
+++ /wiki/SerialDrives.wiki	(revision 494)
@@ -39,5 +39,5 @@
 === 3. Boot the Client ===
 
-Boot the client computer.  * During drive detection, hold down the Alt key, and at the end of drive detection, the BIOS will display "Master at COM Detect". *  The BIOS will now scan the available COM ports on the client (COM 1-7), looking for a server.  You can also configure the BIOS with XTIDECFG to always boot from the serial port (see below).
+Boot the client computer.  * During drive detection, hold down the Alt key, and at the end of drive detection, the BIOS will display "Master at COM Detect". *  The BIOS will now scan the available COM ports on the client (COM 1-7), looking for a server.  If Hotkeys are enabled (MODULE_HOTKEYS), pressing F6 will do the same thing.  And you can also configure the BIOS with XTIDECFG to always boot from the serial port (see below).
 
 If a server is found, the floppy and/or hard disk emulated will appear in the boot menu for the BIOS.  You can now proceed as normal.
@@ -109,8 +109,11 @@
 || 2x || 4800,  9600, 19200,  57.6K, 115.2K, 230.4K ||
 || 4x || 9600, 19200, 38400, 115.2K, 230.4K, 460.8K ||
+|| 8x || 19200, 38400, 115.2K, 230.4K, 460.8K, 921.6K ||
 
 And for completeness, 76.8K and 153.6K can also be set.  The default baud rate is 9600 (115.2K when used in named pipe mode).
 
 Note that in Windows' Device Manager, a high speed COM port may still show that it's maximum speed is 128K baud.  Do not be alarmed, this setting has no impact on what SerDrive does with the Windows API, where the higher speeds are available.  No manual setup of the serial port is required before SerDrive runs.
+
+Theoretically, and this is why the server supports it, 921.6K should be possible with a fast enough card and an 8x multiplier, hosted in a computer that can operate at least twice as fast as a 4.77Mhz 8088 machine.  I have only tested up to 460.8K with actual hardware.  
 
 * _Disable Operation Timeout:_ {{{-t}}} * 
@@ -157,4 +160,6 @@
 Note that in Windows' Device Manager, a high speed COM port may still show that it's maximum speed is 128K baud.  Do not be alarmed, this setting has no impact on what SerDrive does with the Windows API, where the higher speeds are available.  No manual setup of the serial port is required before SerDrive runs.
 
+Theoretically, 921.6K should be possible with a fast enough card and an 8x multiplier, hosted in a computer that can operate at least twice as fast as a 4.77Mhz 8088 machine.  I have only tested up to 460.8K with actual hardware, and ISA hardware with an 8x multiplier is hard to find.  
+
 = Disk Image Format =
 